namespace CMSMicroservice.Application.UserContractCQ.Commands.UpdateUserContract;
public class UpdateUserContractCommandValidator : AbstractValidator<UpdateUserContractCommand>
{
    public UpdateUserContractCommandValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.UserId)
            .NotNull();
        RuleFor(model => model.ContractId)
            .NotNull();
        RuleFor(model => model.SignGuid)
            .NotEmpty();
        RuleFor(model => model.SignedPdfFile)
            .NotEmpty();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateUserContractCommand>.CreateWithOptions((UpdateUserContractCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
